package com.pms.ocp.service.impl;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.pms.ocp.mapper.OcpTenantBaseMapper;
import com.pms.ocp.mapper.OcpTenantExtentMapper;
import com.pms.ocp.mapper.OcpTenantIocnMapper;
import com.pms.ocp.model.dto.OcpTenantGroupIocnDto;
import com.pms.ocp.model.entity.OcpTenantBase;
import com.pms.ocp.model.entity.OcpTenantExtent;
import com.pms.ocp.model.entity.OcpTenantIocn;
import com.pms.ocp.service.OcpTenantIocnService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.TreeSet;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * @author:zhaochengming
 */
@Service
public class OcpTenantIocnServiceImpl extends ServiceImpl<OcpTenantIocnMapper, OcpTenantIocn> implements OcpTenantIocnService {


    @Autowired
    private OcpTenantBaseMapper ocpTenantBaseMapper;

    @Autowired
    private OcpTenantIocnMapper ocpTenantIocnMapper;


    @Autowired
    private OcpTenantExtentMapper ocpTenantExtentMapper;

    /**
     * 我的应用--服务列表
     *
     * @return
     */
    @Override
    public List<OcpTenantGroupIocnDto> getApplyUserList() {
  /*      List<OcpTenantGroupIocnDto> groupIocnDtos = new ArrayList<>();
        List<OcpTenantBase> ocpTenantBases = ocpTenantBaseMapper.selectList(null);
        List<OcpTenantIocn> ocpTenantIocns = ocpTenantIocnMapper.selectList(null);
        List<OcpTenantExtent> ocpTenantExtents = ocpTenantExtentMapper.selectList(null);
        for (OcpTenantBase ocpTenantBase : ocpTenantBases) {
            OcpTenantGroupIocnDto ocpTenantGroupIocnDto = new OcpTenantGroupIocnDto();
            if (ocpTenantBase.getIsDelete() == 0) {
                BeanUtils.copyProperties(ocpTenantBase, ocpTenantGroupIocnDto);
                String tenantCode = ocpTenantBase.getTenantCode();
//                ocpTenantGroupIocnDto.setCompanyCode(ownerCompanyCode);
                for (OcpTenantIocn ocpTenantIocn : ocpTenantIocns) {
                    if (tenantCode.equals(ocpTenantIocn.getCodeNo())) {
                        BeanUtils.copyProperties(ocpTenantIocn, ocpTenantGroupIocnDto);
                    }
                }

                for (OcpTenantExtent ocpTenantExtent : ocpTenantExtents) {
                    if (ocpTenantBase.getTenantCode().equals(ocpTenantExtent.getTenantCode())) {
                        ocpTenantGroupIocnDto.setTenantState(ocpTenantExtent.getTenantState());
                    }
                }

//                for (OcpTenantExtent ocpTenantExtent : ocpTenantExtents) {
//                    if (ocpTenantBase.getTenantCode().equals(ocpTenantExtent.getTenantCode())){
//                        Short tenantState = ocpTenantExtent.getTenantState();
//                        ocpTenantGroupIocnDto.setTenantState(tenantState);
//                    }
//                }
                groupIocnDtos.add(ocpTenantGroupIocnDto);
            }

        }*/
        //pish
        List<OcpTenantGroupIocnDto> lists = new ArrayList<>();
       List<OcpTenantGroupIocnDto> groupIocnDtos = ocpTenantBaseMapper.selectAlls();
        for (OcpTenantGroupIocnDto groupIocnDto : groupIocnDtos) {
            Short isDelete = groupIocnDto.getIsDelete();
            if (isDelete == 0){
                lists.add(groupIocnDto);
            }
        }


        return lists;

    }

    /**
     * 我的应用--轮播图
     *
     * @param tenantCode
     * @return
     */
    @Override
    public List<byte[]> selectPhotosAll(String tenantCode) {
        List<byte[]> list = new ArrayList<>();
        List<OcpTenantIocn> ocpTenantIocn = ocpTenantIocnMapper.selectCodes(tenantCode);
        for (OcpTenantIocn tenantIocn : ocpTenantIocn) {
            byte[] iocn = tenantIocn.getIocn();
            list.add(iocn);
        }


        //去重
//        msgs = msgs.stream().collect(Collectors.collectingAndThen(Collectors.toCollection(() -> new TreeSet<>(Comparator.comparing(Msg :: getMsgId))), ArrayList::new));


        for (byte[] bytes : list) {
            if (!(list.contains(bytes))){
                list.add(bytes);
            }
        }
            return list;
    }

}
